#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 lightSpaceMatrix;
uniform vec3 viewPos;

out vec3 fragNormal;
out vec3 fragPos;
out vec3 fragViewPos;
out vec2 fragUV;
out vec4 fragPosLightSpace;

void main() {
	vec3 transformedNormal = mat3(transpose(inverse(model))) * normal;

	fragNormal = normalize(transformedNormal);
	fragPos = vec3(model * vec4(position, 1.0));
	fragViewPos = viewPos;
	fragUV = uv;
	fragPosLightSpace = lightSpaceMatrix * vec4(fragPos, 1.0);

	gl_Position = projection * view * model * vec4(position, 1);
}
